import wx
import wx.stc as stc
import types

COMMAND_ISSUED = wx.NewEventType()
EVT_COMMAND_ISSUED = wx.PyEventBinder(COMMAND_ISSUED, 1)

#----------------------------------------------------------------------
wxk_map = {
    8 : 'BACK',
    9 : 'TAB',
    13 : 'RETURN',
    27 : 'ESCAPE',
    32 : 'SPACE',
    127 : 'DELETE',
    300 : 'START',
    301 : 'LBUTTON',
    302 : 'RBUTTON',
    303 : 'CANCEL',
    304 : 'MBUTTON',
    305 : 'CLEAR',
    306 : 'SHIFT',
    308 : 'CONTROL',
    309 : 'MENU',
    310 : 'PAUSE',
    311 : 'CAPITAL',
    366 : 'PRIOR',
    367 : 'NEXT',
    312 : 'END',
    313 : 'HOME',
    314 : 'LEFT',
    315 : 'UP',
    316 : 'RIGHT',
    317 : 'DOWN',
    318 : 'SELECT',
    319 : 'PRINT',
    320 : 'EXECUTE',
    321 : 'SNAPSHOT',
    322 : 'INSERT',
    323 : 'HELP',
    324 : 'NUMPAD0',
    325 : 'NUMPAD1',
    326 : 'NUMPAD2',
    327 : 'NUMPAD3',
    328 : 'NUMPAD4',
    329 : 'NUMPAD5',
    330 : 'NUMPAD6',
    331 : 'NUMPAD7',
    332 : 'NUMPAD8',
    333 : 'NUMPAD9',
    334 : 'MULTIPLY',
    335 : 'ADD',
    336 : 'SEPARATOR',
    337 : 'SUBTRACT',
    338 : 'DECIMAL',
    339 : 'DIVIDE',
    340 : 'F1',
    341 : 'F2',
    342 : 'F3',
    343 : 'F4',
    344 : 'F5',
    345 : 'F6',
    346 : 'F7',
    347 : 'F8',
    348 : 'F9',
    349 : 'F10',
    350 : 'F11',
    351 : 'F12',
    352 : 'F13',
    353 : 'F14',
    354 : 'F15',
    355 : 'F16',
    356 : 'F17',
    357 : 'F18',
    358 : 'F19',
    359 : 'F20',
    360 : 'F21',
    361 : 'F22',
    362 : 'F23',
    363 : 'F24',
    364 : 'NUMLOCK',
    365 : 'SCROLL',
    366 : 'PAGEUP',
    367 : 'PAGEDOWN',
    368 : 'SPACE',
    369 : 'TAB',
    370 : 'ENTER',
    371 : 'F1',
    372 : 'F2',
    373 : 'F3',
    374 : 'F4',
    375 : 'HOME',
    376 : 'LEFT',
    377 : 'UP',
    378 : 'RIGHT',
    379 : 'DOWN',
    380 : 'PRIOR',
    380 : 'PAGEUP',
    381 : 'NEXT',
    381 : 'PAGEDOWN',
    382 : 'END',
    383 : 'BEGIN',
    384 : 'INSERT',
    385 : 'DELETE',
    386 : 'EQUAL',
    387 : 'MULTIPLY',
    388 : 'ADD',
    389 : 'SEPARATOR',
    390 : 'SUBTRACT',
    391 : 'DECIMAL',
    392 : 'DIVIDE',
}

command_map= {
    'DOWN':stc.STC_CMD_LINEDOWN,
    'SHIFT+DOWN':stc.STC_CMD_LINEDOWNEXTEND,
    'CTRL+DOWN':stc.STC_CMD_LINESCROLLDOWN,
    'ALT+SHIFT+DOWN':stc.STC_CMD_LINEDOWNRECTEXTEND,
    'UP':stc.STC_CMD_LINEUP,
    'SHIFT+UP':stc.STC_CMD_LINEUPEXTEND,
    'CTRL+UP':stc.STC_CMD_LINESCROLLUP,
    'ALT+SHIFT+UP':stc.STC_CMD_LINEUPRECTEXTEND,
    'CTRL+[':stc.STC_CMD_PARAUP,
    'CTRL+SHIFT+[':stc.STC_CMD_PARAUPEXTEND,
    'CTRL+]':stc.STC_CMD_PARADOWN,
    'CTRL+SHIFT+]':stc.STC_CMD_PARADOWNEXTEND,
    'LEFT':stc.STC_CMD_CHARLEFT,
    'SHIFT+LEFT':stc.STC_CMD_CHARLEFTEXTEND,
    'CTRL+LEFT':stc.STC_CMD_WORDLEFT,
    'CTRL+SHIFT+LEFT':stc.STC_CMD_WORDLEFTEXTEND,
    'ALT+SHIFT+LEFT':stc.STC_CMD_CHARLEFTRECTEXTEND,
    'RIGHT':stc.STC_CMD_CHARRIGHT,
    'SHIFT+RIGHT':stc.STC_CMD_CHARRIGHTEXTEND,
    'CTRL+RIGHT':stc.STC_CMD_WORDRIGHT,
    'CTRL+SHIFT+RIGHT':stc.STC_CMD_WORDRIGHTEXTEND,
    'ALT+SHIFT+RIGHT':stc.STC_CMD_CHARRIGHTRECTEXTEND,
    'CTRL+/':stc.STC_CMD_WORDPARTLEFT,
    'CTRL+SHIFT+/':stc.STC_CMD_WORDPARTLEFTEXTEND,
    'CTRL+\\':stc.STC_CMD_WORDPARTRIGHT,
    'CTRL+SHIFT+\\':stc.STC_CMD_WORDPARTRIGHTEXTEND,
    'HOME':stc.STC_CMD_VCHOME,
    'SHIFT+HOME':stc.STC_CMD_VCHOMEEXTEND,
    'CTRL+HOME':stc.STC_CMD_DOCUMENTSTART,
    'CTRL+SHIFT+HOME':stc.STC_CMD_DOCUMENTSTARTEXTEND,
    'ALT+HOME':stc.STC_CMD_HOMEDISPLAY,
    'ALT+SHIFT+HOME':stc.STC_CMD_HOMEDISPLAYEXTEND,
    'ALT+SHIFT+HOME':stc.STC_CMD_VCHOMERECTEXTEND,
    'END':stc.STC_CMD_LINEEND,
    'SHIFT+END':stc.STC_CMD_LINEENDEXTEND,
    'CTRL+END':stc.STC_CMD_DOCUMENTEND,
    'CTRL+SHIFT+END':stc.STC_CMD_DOCUMENTENDEXTEND,
    'ALT+END':stc.STC_CMD_LINEENDDISPLAY,
    'ALT+SHIFT+END':stc.STC_CMD_LINEENDDISPLAYEXTEND,
    'ALT+SHIFT+END':stc.STC_CMD_LINEENDRECTEXTEND,
    'PRIOR':stc.STC_CMD_PAGEUP,
    'SHIFT+PRIOR':stc.STC_CMD_PAGEUPEXTEND,
    'ALT+SHIFT+PRIOR':stc.STC_CMD_PAGEUPRECTEXTEND,
    'NEXT':stc.STC_CMD_PAGEDOWN,
    'SHIFT+NEXT':stc.STC_CMD_PAGEDOWNEXTEND,
    'ALT+SHIFT+NEXT':stc.STC_CMD_PAGEDOWNRECTEXTEND,
    'DELETE':stc.STC_CMD_CLEAR,
    'SHIFT+DELETE':stc.STC_CMD_CUT,
    'CTRL+DELETE':stc.STC_CMD_DELWORDRIGHT,
    'CTRL+SHIFT+DELETE':stc.STC_CMD_DELLINERIGHT,
    'INSERT':stc.STC_CMD_EDITTOGGLEOVERTYPE,
    'SHIFT+INSERT':stc.STC_CMD_PASTE,
    'CTRL+INSERT':stc.STC_CMD_COPY,
    'ESCAPE':stc.STC_CMD_CANCEL,
    'BACK':stc.STC_CMD_DELETEBACK,
    'SHIFT+BACK':stc.STC_CMD_DELETEBACK,
    'CTRL+BACK':stc.STC_CMD_DELWORDLEFT,
    'ALT+BACK':stc.STC_CMD_UNDO,
    'CTRL+SHIFT+BACK':stc.STC_CMD_DELLINELEFT,
    'CTRL+Z':stc.STC_CMD_UNDO,
    'CTRL+Y':stc.STC_CMD_REDO,
    'CTRL+X':stc.STC_CMD_CUT,
    'CTRL+C':stc.STC_CMD_COPY,
    'CTRL+V':stc.STC_CMD_PASTE,
    'CTRL+A':stc.STC_CMD_SELECTALL,
    'TAB':stc.STC_CMD_TAB,
    'SHIFT+TAB':stc.STC_CMD_BACKTAB,
    'RETURN':stc.STC_CMD_NEWLINE,
    'SHIFT+RETURN':stc.STC_CMD_NEWLINE,
    'CTRL+ADD':stc.STC_CMD_ZOOMIN,
    'CTRL+SUBTRACT':stc.STC_CMD_ZOOMOUT,
    # 'CTRL+DIVIDE':stc.STC_CMD_SETZOOM,
    'CTRL+L':stc.STC_CMD_LINECUT,
    'CTRL+SHIFT+L':stc.STC_CMD_LINEDELETE,
    'CTRL+SHIFT+T':stc.STC_CMD_LINECOPY,
    'CTRL+T':stc.STC_CMD_LINETRANSPOSE,
    'CTRL+D':stc.STC_CMD_LINEDUPLICATE,
    'CTRL+U':stc.STC_CMD_LOWERCASE,
    'CTRL+SHIFT+U':stc.STC_CMD_UPPERCASE,
}
#----------------------------------------------------------------------

class CommandIssuedEvent(wx.PyCommandEvent):
    def __init__(self, id, cmd):
        wx.PyCommandEvent.__init__(self, COMMAND_ISSUED, id)
        self.cmd = cmd

def decode_key_event(evt):
    ret = ""
    if evt.ControlDown():
        ret +="CTRL+"
    if evt.AltDown():
        ret +="ALT+"
    if evt.ShiftDown():
        ret +="SHIFT+"
    if evt.KeyCode in wxk_map:
        ret += wxk_map[evt.KeyCode]
    else:            
        if evt.KeyCode <256:
            ret +=  chr(evt.KeyCode)
    return ret

class CustomSTC(stc.StyledTextCtrl):
    def __init__(self, parent):
        stc.StyledTextCtrl.__init__(self, parent)
        
        self.CmdKeyClearAll()
        self.command_map = command_map
        
        self.Bind(wx.EVT_KEY_DOWN, self.OnKeyPressed)
        self.Bind(stc.EVT_STC_UPDATEUI, self.OnUpdateUI)
        self.Bind(stc.EVT_STC_MARGINCLICK, self.OnMarginClick)
        
    def OnKeyPressed(self, evt):
        key_name = decode_key_event(evt)
        if key_name in self.command_map:
            cmd = self.command_map[key_name]
            if type(cmd) is types.IntType:
                self.CmdKeyExecute(cmd)
            else:
                cmd(self)
        else:
            if len(key_name)>1: # if is anything else but a char
                self.GetEventHandler().ProcessEvent(CommandIssuedEvent(self.GetId(), key_name))
            evt.Skip()
            
    def OnUpdateUI(self, evt):
        # check for matching braces
        braceAtCaret = -1
        braceOpposite = -1
        charBefore = None
        caretPos = self.GetCurrentPos()

        if caretPos > 0:
            charBefore = self.GetCharAt(caretPos - 1)
            styleBefore = self.GetStyleAt(caretPos - 1)

        # check before
        if charBefore and chr(charBefore) in "[]{}()" and styleBefore == stc.STC_P_OPERATOR:
            braceAtCaret = caretPos - 1

        # check after
        if braceAtCaret < 0:
            charAfter = self.GetCharAt(caretPos)
            styleAfter = self.GetStyleAt(caretPos)

            if charAfter and chr(charAfter) in "[]{}()" and styleAfter == stc.STC_P_OPERATOR:
                braceAtCaret = caretPos

        if braceAtCaret >= 0:
            braceOpposite = self.BraceMatch(braceAtCaret)

        if braceAtCaret != -1  and braceOpposite == -1:
            self.BraceBadLight(braceAtCaret)
        else:
            self.BraceHighlight(braceAtCaret, braceOpposite)

    def OnMarginClick(self, evt):
        # fold and unfold as needed
        if evt.GetMargin() == 2:
            if evt.GetShift() and evt.GetControl():
                self.FoldAll()
            else:
                lineClicked = self.LineFromPosition(evt.GetPosition())

                if self.GetFoldLevel(lineClicked) & stc.STC_FOLDLEVELHEADERFLAG:
                    if evt.GetShift():
                        self.SetFoldExpanded(lineClicked, True)
                        self.Expand(lineClicked, True, True, 1)
                    elif evt.GetControl():
                        if self.GetFoldExpanded(lineClicked):
                            self.SetFoldExpanded(lineClicked, False)
                            self.Expand(lineClicked, False, True, 0)
                        else:
                            self.SetFoldExpanded(lineClicked, True)
                            self.Expand(lineClicked, True, True, 100)
                    else:
                        self.ToggleFold(lineClicked)

    def FoldAll(self):
        lineCount = self.GetLineCount()
        expanding = True

        # find out if we are folding or unfolding
        for lineNum in range(lineCount):
            if self.GetFoldLevel(lineNum) & stc.STC_FOLDLEVELHEADERFLAG:
                expanding = not self.GetFoldExpanded(lineNum)
                break

        lineNum = 0

        while lineNum < lineCount:
            level = self.GetFoldLevel(lineNum)
            if level & stc.STC_FOLDLEVELHEADERFLAG and \
               (level & stc.STC_FOLDLEVELNUMBERMASK) == stc.STC_FOLDLEVELBASE:

                if expanding:
                    self.SetFoldExpanded(lineNum, True)
                    lineNum = self.Expand(lineNum, True)
                    lineNum = lineNum - 1
                else:
                    lastChild = self.GetLastChild(lineNum, -1)
                    self.SetFoldExpanded(lineNum, False)

                    if lastChild > lineNum:
                        self.HideLines(lineNum+1, lastChild)

            lineNum = lineNum + 1



    def Expand(self, line, doExpand, force=False, visLevels=0, level=-1):
        lastChild = self.GetLastChild(line, level)
        line = line + 1

        while line <= lastChild:
            if force:
                if visLevels > 0:
                    self.ShowLines(line, line)
                else:
                    self.HideLines(line, line)
            else:
                if doExpand:
                    self.ShowLines(line, line)

            if level == -1:
                level = self.GetFoldLevel(line)

            if level & stc.STC_FOLDLEVELHEADERFLAG:
                if force:
                    if visLevels > 1:
                        self.SetFoldExpanded(line, True)
                    else:
                        self.SetFoldExpanded(line, False)

                    line = self.Expand(line, doExpand, force, visLevels-1)

                else:
                    if doExpand and self.GetFoldExpanded(line):
                        line = self.Expand(line, True, force, visLevels-1)
                    else:
                        line = self.Expand(line, False, force, visLevels-1)
            else:
                line = line + 1

        return line