import wx
import wx.stc as stc

if wx.Platform == '__WXMSW__':
    faces = { 'times': 'Times New Roman',
              'mono' : 'DejaVu Sans Mono',
              'helv' : 'Arial',
              'other': 'Comic Sans MS',
              'size' : 8,
              'size2': 6,
             }
elif wx.Platform == '__WXMAC__':
    faces = { 'times': 'Times New Roman',
              'mono' : 'Courier New',
              'helv' : 'Arial',
              'other': 'Comic Sans MS',
              'size' : 12,
              'size2': 10,
             }
else:
    faces = { 'times': 'Times',
              'mono' : 'Courier',
              'helv' : 'Helvetica',
              'other': 'new century schoolbook',
              'size' : 12,
              'size2': 10,
             }

def PythonSkin(target):
    target.SetProperty("fold", "1")
    target.SetProperty("tab.timmy.whinge.level", "1")
    target.SetMargins(0,0)

    target.SetViewWhiteSpace(False)
    # target.SetBufferedDraw(False)
    #target.SetViewEOL(True)
    #target.SetEOLMode(stc.STC_EOL_CRLF)
    #target.SetUseAntiAliasing(True)
    
    target.SetEdgeMode(stc.STC_EDGE_LINE)
    target.SetEdgeColumn(78)
    target.SetMargins(2,2)

    # Set up the numbers in the margin for margin #1
    target.SetMarginType(1, stc.STC_MARGIN_NUMBER)
    # Reasonable value for, say, 4-5 digits using a mono font (40 pix)
    target.SetMarginWidth(1, 40)
    # Setup a margin to hold fold markers
    #target.SetFoldFlags(16)  ###  WHAT IS THIS VALUE?  WHAT ARE THE OTHER FLAGS?  DOES IT MATTER?
    target.SetMarginType(2, stc.STC_MARGIN_SYMBOL)
    target.SetMarginMask(2, stc.STC_MASK_FOLDERS)
    target.SetMarginSensitive(2, True)
    target.SetMarginWidth(2, 12)

    target.MarkerDefine(stc.STC_MARKNUM_FOLDEROPEN,    stc.STC_MARK_BOXMINUS,          "white", "#808080")
    target.MarkerDefine(stc.STC_MARKNUM_FOLDER,        stc.STC_MARK_BOXPLUS,           "white", "#808080")
    target.MarkerDefine(stc.STC_MARKNUM_FOLDERSUB,     stc.STC_MARK_VLINE,             "white", "#808080")
    target.MarkerDefine(stc.STC_MARKNUM_FOLDERTAIL,    stc.STC_MARK_LCORNER,           "white", "#808080")
    target.MarkerDefine(stc.STC_MARKNUM_FOLDEREND,     stc.STC_MARK_BOXPLUSCONNECTED,  "white", "#808080")
    target.MarkerDefine(stc.STC_MARKNUM_FOLDEROPENMID, stc.STC_MARK_BOXMINUSCONNECTED, "white", "#808080")
    target.MarkerDefine(stc.STC_MARKNUM_FOLDERMIDTAIL, stc.STC_MARK_TCORNER,           "white", "#808080")

    # Make some styles,  The lexer defines what each style is used for, we
    # just have to define what each style looks like.  This set is adapted from
    # Scintilla sample property files.

    # Global default styles for all languages
    target.StyleSetSpec(stc.STC_STYLE_DEFAULT,     "face:%(mono)s,size:%(size)d" % faces)
    target.StyleClearAll()  # Reset all to be like the default

    # Line numbers in margin
    target.StyleSetSpec(stc.STC_STYLE_LINENUMBER,'fore:#000000,back:#99A9C2')    
    # Highlighted brace
    target.StyleSetSpec(stc.STC_STYLE_BRACELIGHT,'fore:#00009D,back:#FFFF00')
    # Unmatched brace
    target.StyleSetSpec(stc.STC_STYLE_BRACEBAD,'fore:#00009D,back:#FF0000')
    # Indentation guide
    target.StyleSetSpec(stc.STC_STYLE_INDENTGUIDE, "fore:#CDCDCD")

    # Python styles
    target.StyleSetSpec(stc.STC_P_DEFAULT, 'fore:#000000')
    # Comments
    target.StyleSetSpec(stc.STC_P_COMMENTLINE,  'fore:#008000,back:#F0FFF0')
    target.StyleSetSpec(stc.STC_P_COMMENTBLOCK, 'fore:#008000,back:#F0FFF0')
    # Numbers
    target.StyleSetSpec(stc.STC_P_NUMBER, 'fore:#008080')
    # Strings and characters
    target.StyleSetSpec(stc.STC_P_STRING, 'fore:#800080')
    target.StyleSetSpec(stc.STC_P_CHARACTER, 'fore:#800080')
    # Keywords
    target.StyleSetSpec(stc.STC_P_WORD, 'fore:#000080,bold')
    # Triple quotes
    target.StyleSetSpec(stc.STC_P_TRIPLE, 'fore:#800080,back:#FFFFEA')
    target.StyleSetSpec(stc.STC_P_TRIPLEDOUBLE, 'fore:#800080,back:#FFFFEA')
    # Class names
    target.StyleSetSpec(stc.STC_P_CLASSNAME, 'fore:#0000FF,bold')
    # Function names
    target.StyleSetSpec(stc.STC_P_DEFNAME, 'fore:#008080,bold')
    # Operators
    target.StyleSetSpec(stc.STC_P_OPERATOR, 'fore:#800000,bold')
    # Identifiers. I leave this as not bold because everything seems
    # to be an identifier if it doesn't match the above criterae
    target.StyleSetSpec(stc.STC_P_IDENTIFIER, 'fore:#000000')

    # Caret color
    target.SetCaretForeground("BLUE")
    # Selection background
    target.SetSelBackground(1, '#DDDDFF')
